> For the complete documentation index, see [llms.txt](https://docs.os.uk/os-downloads/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.os.uk/os-downloads/products/water-portfolio/os-open-rivers/os-open-rivers-technical-specification/feature-types/watercourselink.md).

# WatercourseLink

The WatercourseLink feature is a generalised representation of the watercourse alignment. WatercourseLink features are split where their real-world related attribution changes or where they meet to form a junction.

## WatercourseLink attributes

A segment that forms part of a watercourse.

{% hint style="info" %}

### Attribute naming across formats

Attribute names will vary slightly depending on what format you receive your data in (GML, Esri shapefile, GeoPackage or vector tiles). The attribute names on the feature type pages are written as they will appear in GML format. Attribute name mapping tables between GML and the other three formats for each feature type are present in the following pages:

* [Esri shapefile overview](/os-downloads/products/water-portfolio/os-open-rivers/os-open-rivers-technical-specification/esri-shapefile-overview.md)
* [GeoPackage overview](/os-downloads/products/water-portfolio/os-open-rivers/os-open-rivers-technical-specification/geopackage-overview.md)
* [Vector tiles overview](/os-downloads/products/water-portfolio/os-open-rivers/os-open-rivers-technical-specification/vector-tiles-overview.md)
  {% endhint %}

### gml:id

Unique identifier. For WatercourseLink this is a GUID, which is not persistent.

* **Attribute name:** gml:id
* **Type:** CharacterString
* **Length:** 38
* **Multiplicity:** \[1]

### flowDirection «voidable»

Direction of water flow in the segment relative to digitisation of segment geometry.

* **Attribute name:** flowDirection
* **Type:** [LinkDirectionValue](https://docs.os.uk/os-downloads/networks/os-open-rivers/os-open-rivers-technical-specification/code-lists/linkdirectionvalue)
* **Multiplicity:** \[1]

### length «voidable»

Length of network segment.

* **Attribute name:** length (GML)
* **Multiplicity:** \[1]

### centrelineGeometry

The geometry that represents the centreline of the link.

* **Attribute name:** centrelineGeometry
* **Type:** GM\_Curve
* **Multiplicity:** \[1]

### fictitious

Indicator that the centreline geometry of the link is a straight line with no intermediate control points – unless the straight line represents the geography in the resolution of the data set appropriately.

* **Attribute name:** centrelineGeometry
* **Type:** Boolean
* **Multiplicity:** \[1]

### form «voidable»

Classification of the type of watercourse that is formed by the WatercourseLink.

* **Attribute name:** form
* **Type:** [WatercourseFormValue](https://docs.os.uk/os-downloads/networks/os-open-rivers/os-open-rivers-technical-specification/code-lists/watercourseformvalue)
* **Multiplicity:** \[1]

### watercourseName

Recognised name assigned to the watercourse.

{% hint style="info" %}
The language used to define the name shall also be provided as a three-digit ISO 639-2 code ('eng', 'cym' 'gla'). Note 2: Where a watercourse has a name in more than one language, this attribute will be the Welsh or Gaelic version.
{% endhint %}

* **Attribute name:** watercourseName
* **Type:** LocalisedCharacterString
* **Multiplicity:** \[0..1]

### watercourseNameAlternative

An alternative name of the main watercourse the link is part of. Note 1: The language used to define the name shall also be provided as a three-digit ISO 639-2 code ('eng', 'cym' 'gla').

{% hint style="info" %}
Where a watercourse has a name in more than one language, this attribute will be the English version.
{% endhint %}

* **Attribute name:** watercourseNameAlternative
* **Type:** LocalisedCharacterString
* **Multiplicity:** \[0..1]

### startNode

The HydroNode coincident with the first vertex for this WatercourseLink.

* **Attribute name:** startNode
* **Multiplicity:** \[0..1]

### endNode

The HydroNode coincident with the last vertex for this WatercourseLink. On very rare occasions, the end HydroNode may be the same instance as the start HydroNode.

* **Attribute name:** endNode
* **Multiplicity:** \[0..1]


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.os.uk/os-downloads/products/water-portfolio/os-open-rivers/os-open-rivers-technical-specification/feature-types/watercourselink.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
